/*
 * Copywrite 1997 Edscott Wilson Garcia 
 *
 * GPL licence. No warranty. Read license for details
 *
 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#ifdef HAVE_SYS_STAT_H
#include <sys/stat.h>
#endif

#ifdef HAVE_SYS_TYPES_H
#include <sys/types.h>
#endif

#ifdef HAVE_SYS_TIME_H
#include <sys/time.h>
#endif

#ifdef HAVE_PWD_H
#include <pwd.h>
#endif

#ifdef HAVE_GLOB_H
#include <glob.h>
#endif

#ifdef HAVE_MEMORY_H
#include <memory.h>
#endif

#ifdef HAVE_STDIO_H
#include <stdio.h>
#endif

#ifdef HAVE_STDLIB_H
#include <stdlib.h>
#endif

#ifdef HAVE_STRING_H
#include <string.h>
#endif

#ifdef HAVE_TIME_H
#include <time.h>
#endif

#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif

#ifdef HAVE_UTIME_H
#include <utime.h>
#endif

#include  <locale.h>
#include "intl.h"

#define notTEST
#define PURGE
#define BLOCKSIZE 64000
#define ENCRYPT 1
#define DECRYPT 2
#define KEY_PROMPT "==>"

/* in order to support boxes where GLOB_NOMATCH is not
 * defined, all return error codes will be interpreted
 * as GLOB_NOMATCH */
/* in gnu-c, GLOB_NOMATCH is 3 */


unsigned char buff;


char *key;
int verbose=0,purge=1,opcion=0,recursivo=0,cryptcount=0,keypos=0,keyset=0,keylen;
int resetdate=1;
void cifrador(char *);
void realcrypt(char *);

int main(int argc,char **argv)
{
 char *input;
 int filearg=1;

#ifdef ENABLE_NLS
    setlocale (LC_MESSAGES, "");
    setlocale (LC_ALL, "");
    bindtextdomain(PACKAGE, PACKAGE_LOCALE_DIR);
    textdomain(PACKAGE);
#endif

  if (argc >= 2 && strcmp(argv[1],"-V")==0){
    printf(_("scramble version %s (GPL 1997-2005)"),VERSION);
    printf("\n");
    exit(1);
  }
  if (argc < 2){
    error:
    printf(_("Usage: scramble  [-redkv] file"));
    printf("\n"); printf("\n");
    printf(_(" -r (recursive)\n -e (encrypt)\n -d (decrypt)\n -k (don't purge when -e specified)\n -b (purge when -d specified)\n -v (verbose)\n -V (version infomation) \n\nBy default, scramble will purge with -e and will not purge with -d"));
    printf("\n"); printf("\n");
    goto endit;  
  }
  if (strstr(argv[0],"unscramble")){
      opcion=DECRYPT; purge=0;
  } else {
      opcion=ENCRYPT; purge=1;
  }
if (argv[1][0] == '-') {
  filearg++;
  if ( (strstr(argv[1],"k")!=NULL) && (strstr(argv[1],"b")!=NULL)) goto error;
  if (strstr(argv[1],"e")!=NULL) {opcion=ENCRYPT; purge=1;}
  if (strstr(argv[1],"d")!=NULL) {opcion=DECRYPT; purge=0;}
  if (strstr(argv[1],"r")!=NULL) recursivo=1;
  if (strstr(argv[1],"k")!=NULL) purge=0;
  if (strstr(argv[1],"b")!=NULL) purge=1;
  if (strstr(argv[1],"v")!=NULL) verbose=1;
  if (strstr(argv[1],"u")!=NULL) {verbose=1;}
  if (strstr(argv[1],"w")!=NULL) resetdate=0;
}



 { 
	 int i;
	 for (i=filearg;i<argc;i++)
	 {
		 input=(char *)malloc(strlen(argv[i])+25);
		 sprintf(input,"%s",argv[i]);
		 if (verbose) {
		     printf(_("processing file \"%s\" (%d/%d)"),input,i-1,argc-2);
		    printf("\n"); 
		 }
		 cifrador(input);
		 free(input);
	 }
 }

 
/* cero out passwd:*/
 for (keypos=0;keypos<keylen;keypos++) key[keypos]=0;
 if (cryptcount) {
     printf("\n");
     if (opcion==ENCRYPT) {
	printf(ngettext(
		    "%d file was scrambled.",
		    "%d files were scrambled.",
		cryptcount),cryptcount);
     } else {
	printf(ngettext(
		    "%d file was unscrambled.",
		    "%d files were unscrambled.",
		    cryptcount),cryptcount);
     }
     printf("\n");
 }
 else {
     printf(_("No file to process."));
     printf("\n");
 }

endit:
 printf(_("press <return> to continue..."));fflush(NULL);
 getc(stdin);
 return 1;
}

char *OKchars="( -_~./;+&@)";
struct stat st;

void cifrador(char *input) {
 glob_t  dirlist;
 int i;
/* check for fichero*/
  
 dirlist.gl_offs=2;
#ifdef DEBUG
 printf("DBG--> globbing \"%s\"\n",input);
#endif

#ifndef GLOB_PERIOD
#define GLOB_PERIOD 0
#endif
 
 if (glob(input,GLOB_ERR | GLOB_PERIOD,NULL,&dirlist)!=0) 
 {
#ifdef DEBUG
 printf("%s: empty\n",input); 
#endif
  return;
 }

#ifdef DEBUG
 printf ("cuenta=%d\n",dirlist.gl_pathc);
#endif
 for (i=0;i<dirlist.gl_pathc;i++) {
     if (strchr(dirlist.gl_pathv[i],'/') && 
	(strcmp(strrchr(dirlist.gl_pathv[i],'/'),"/.")==0 ||
	strcmp(strrchr(dirlist.gl_pathv[i],'/'),"/..")==0)) continue;
#ifdef DEBUG
  printf("DBG--> %s\n",dirlist.gl_pathv[i]);
#endif
 
  stat(dirlist.gl_pathv[i],&st);
  if ((S_IFMT&st.st_mode)==S_IFDIR) {
   if (recursivo==1) {
    char *Ninput;
    Ninput=(char *)malloc(strlen(dirlist.gl_pathv[i])+25);
    if (verbose) {
	if (opcion==ENCRYPT) {
	    printf(_("Directory \"%s\" will be scrambled recursively"),input);
	} else {
	    printf(_("Directory \"%s\" will be unscrambled recursively"),input);
	}
	printf("\n");
    }
    sprintf(Ninput,"%s/*",dirlist.gl_pathv[i]);
    cifrador(Ninput);
    free(Ninput);
   }
   else { 
       fprintf(stderr,_("Input path \"%s\" is a directory"),dirlist.gl_pathv[i]);
     fprintf(stderr,"\n");
   }
  } else {
   int j;
   /* test for metachars */
   for (j=0;j<strlen(dirlist.gl_pathv[i]);j++) {
    int k;
    if ((dirlist.gl_pathv[i][j]<='z')&&(dirlist.gl_pathv[i][j]>='a')) goto OK;
    if ((dirlist.gl_pathv[i][j]<='Z')&&(dirlist.gl_pathv[i][j]>='A')) goto OK;
    if ((dirlist.gl_pathv[i][j]<='9')&&(dirlist.gl_pathv[i][j]>='0')) goto OK;
    for (k=0;k<strlen(OKchars);k++)  if (dirlist.gl_pathv[i][j]==OKchars[k]) goto OK;
     printf("\n");
     printf(_("Please rename file \"%s\" before scrambling."),dirlist.gl_pathv[i]);
     printf("\n");
    goto skip;
    OK:;
   }
   realcrypt(dirlist.gl_pathv[i]);
   skip:;
  }
 }
 globfree(&dirlist);
#ifdef DEBUG
 printf("OK\n");
#endif
 return;
}

void realcrypt(char *input)
{
 /*struct stat stN;*/
 FILE *infile,*outfile;
 char *archivo,*archi;
 int filesize,fileplace;

 archivo=(char *)malloc(strlen(input)+25);


 if (opcion==DECRYPT) {
  int longitud;
  longitud=strlen(input);
  if ((input[longitud-1]!='t')||(input[longitud-2]!='y')||
       (input[longitud-3]!='c')||(input[longitud-4]!='.')) {
   fprintf(stderr,_("Input file \"%s\" is not a scambled type (.cyt)"),input); 
     printf("\n");
   return;
  } 
  sprintf(archivo,"%s",input);
  archivo[longitud-4]=0;
     printf(_("Unscrambling file \"%s\" to \"%s\""),input,archivo);
     printf("\n");
 } else { /*ENCRYPT   */
  int longitud;
  longitud=strlen(input);
  if ((input[longitud-1]=='t')&&(input[longitud-2]=='y')&&
       (input[longitud-3]=='c')&&(input[longitud-4]=='.')) {
   fprintf(stderr,_("Input file \"%s\" is already a scrambled type (.cyt)"),input); 
     printf("\n");
   return;
  } 
  sprintf(archivo,"%s.cyt",input);
     printf(_("Scrambling \"%s\" to \"%s\""),input,archivo);
     printf("\n");
 }

 infile=fopen(input,"rb");
 if (infile==NULL) {
     fprintf(stderr,_("File not found: \"%s\""),input);
     printf("\n");
     return;
 }
 /* get file size*/
 fseek(infile,0,SEEK_END); filesize = ftell(infile); rewind(infile); 
 cryptcount++;

/* key*/
/* very important:*/
   keypos=0; 
 
 
  if (keyset==0) {
  char buff[128];
  keyset=1;
  printf("%s ",_("key"));fflush(NULL);
  key=(char *)getpass(KEY_PROMPT);
  keylen=strlen(key);
  strncpy(buff,key,128);
  /* confirma para evitar desastres:*/
  printf("%s ",_("Confirm the key (avoid disasters)"));fflush(NULL);
  key=(char *)getpass(KEY_PROMPT);
  if (strcmp(buff,key)!=0){
      fprintf(stderr,_("The second key does not match the first key")); 
     fprintf(stderr,"\n");
      goto endit;
  }
  if (keylen<8) {
    fprintf(stderr,_("The key cannot be less than 8 characters"));
     fprintf(stderr,"\n");
endit:
    exit(1);
  }
 }
 
 /*printf("using key %s\n",key);*/
#ifndef TEST
 
 outfile=fopen(archivo,"wb");
 if (outfile==NULL) {
     fprintf(stderr,_("Cannot generate output file: \"%s\""),archivo);
     fprintf(stderr,"\n");
     return;
 }

/* printf("longitud llave=%d, llave=%s\n",keylen,key);*/

 archi=(char *)malloc(BLOCKSIZE);

 fileplace=0;
 while (fileplace<filesize){
  void crypter(char *,int);
  int readblock;
  if (filesize-fileplace>=BLOCKSIZE) readblock=BLOCKSIZE; else readblock=filesize-fileplace;
  /*printf("reading %d / %d\n",fileplace,filesize);*/
  fread(archi,readblock,1,infile);
  crypter(archi,readblock);
  fwrite(archi,readblock,1,outfile);
  fileplace += readblock;           
 }


 fclose(infile);
 
 fclose(outfile);
 
 if (resetdate) {/*/ dont change the access time:*/
  struct utimbuf times;
  times.modtime=st.st_mtime; /* modification time of unencrypted file*/
  times.actime=st.st_atime;  /* access time of unencrypted file crypted file*/
  utime(archivo,&times);
 }

#ifdef PURGE
 {
  int result;
  if (purge){
    infile=fopen(input,"rb+");
    if (infile) { /* shred before removing */
	fileplace=0;
	while (fileplace<filesize){
	    void crypter(char *,int);
	    int readblock;
	    if (filesize-fileplace>=BLOCKSIZE) readblock=BLOCKSIZE; else readblock=filesize-fileplace;
	    crypter(archi,readblock);
	    fwrite(archi,readblock,1,infile);
	    fileplace += readblock; 
	}
	fclose(infile);
    }
     
    result=remove(input);
    if (result<0) {
	fprintf(stderr,_("Cannot remove: \"%s\""),input);
     fprintf(stderr,"\n");
    }
  }
 }
#endif


#endif 

if (verbose) {
 if (opcion==DECRYPT) {
     printf(_("File unscrambled: \"%s\""),archivo);
     printf("\n");
 }
 else {
     printf(_("File scrambled: \"%s\""),archivo);
     printf("\n");
 }
}else{
 printf("."); 
 fflush(stdout);
}

 free(archivo);
 free(archi);
 return;
}




void crypter(char *data,int length){
 int i;
 for (i=0;i<length;i++){
  if (opcion==DECRYPT) data[i] -= key[keypos++];
  else data[i] += key[keypos++];
  if (keypos==keylen) keypos=0;
 }
}

